<?php
/*
 Plugin Name: Awasete Yomitai for Wordpress
 Plugin URI: http://wordpress.org/extend/plugins/awasete-yomitai-for-wordpress/
 Description: Awasete Yomitai for Wordpress. Wordpress 2.8+
 Version: 1.0
 Author: makoto_kw
 Author URI: http://www.makotokw.com/
 */
/*  Copyright 2009 makoto_kw (email : makoto.kw+wordpress@gmail.com)
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.
	
	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.
	
	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

if (class_exists("WP_Widget")) {
	
	class AwaseteYomitai_Widget extends WP_Widget {
	
		static function init() {
			register_widget('AwaseteYomitai_Widget');
		}
		
		static $singleton = null;
		function AwaseteYomitai_Widget() {
			parent::WP_Widget('awaste_yomitai', 'あわせて読みたい', array('description'=>'あわせて読みたい'));
			if (!self::$singleton) {
				self::$singleton = $this;
				add_action('wp_head', array($this,'header'));
				add_action('wp_footer', array($this,'footer'));
			}
		}
	
		function widget($args, $instance) {
			extract($args);
			$this->displaycount = intval($instance['displaycount']); // cache
			$title = $instance['title'];
			if (empty($title)) $title = $this->name;
			$this->url = $instance['url'];
			if (empty($this->url)) $this->url = get_bloginfo('url');
			$u = $this->url;
			?>
				<?php echo $before_widget; ?>
					<?php echo $before_title. $title. $after_title; ?>
					<ul id="awasete_blog_list">
						<li class="awasete_loading">LOADING...</li>
					</ul>
					<div class="awasete_footer">powered by <a href="http://awasete.com/show.phtml?u=<?php echo urlencode($u)?>" title="awasate.com">awasate.com</a></div>
				<?php echo $after_widget; ?>
			<?php
		}
	
		function update($new_instance, $old_instance) {
			return $new_instance;
		}
	
		function form($instance) {
			$title = esc_attr($instance['title']);
			$url = @$instance['url'];
			$displaycount = intval($instance['displaycount']);
			$poweredby = ($instance['poweredby']) ? true : false;
			if ($displaycount<=0) $displaycount = 5;
			?>
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url'); ?>"><?php _e('Url:'); ?></label>
				<input class="widefat" id="<?php echo $this->get_field_id('url'); ?>" name="<?php echo $this->get_field_name('url'); ?>" type="text" value="<?php echo $url; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('displaycount'); ?>"><?php _e('Display Count:'); ?></label>
				<input id="<?php echo $this->get_field_id('displaycount'); ?>" name="<?php echo $this->get_field_name('displaycount'); ?>" type="text" size="3" value="<?php echo $displaycount; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('powerdby'); ?>"><?php _e('Display powered by awasete.com:'); ?></label>
				<input id="<?php echo $this->get_field_id('powerdby'); ?>" name="<?php echo $this->get_field_name('powerdby'); ?>" type="check" value="<?php echo $displaycount; ?>" />
			</p>
			<?php 
		}
	
		function header() {
			$dir = end(explode(DIRECTORY_SEPARATOR, dirname(__FILE__)));
			$u = get_bloginfo('url').'/wp-content/plugins/'.$dir.'/';
			?>
			<link rel="stylesheet" type="text/css" href="<?php echo $u?>awasete-yomitai.css" />
			<?php
		}
	
		function footer() {
			$u = $this->url;
			$max = $this->displaycount;
			if (empty($max) || $max<=0) $max = 5;
			?>
<script type="text/javascript">
function awasete_yomitai(blogs) {
	//var blogs = [{titile:,url:,favicon:,more:},...];
	var el = document.getElementById('awasete_blog_list');
	if (el) {
		var max = <?php echo $max?>, a = [], len = Math.min(max,blogs.length);
		for (var i=0; i<len; i++) {
			var b = blogs[i];
			a.push('<li style="background:transparent url('+b.favicon+') no-repeat left" class="awasete_blog"><a href='+b.url+' title="'+b.title+'">'+b.title+'<\/a><\/li>');
			}
		el.innerHTML = a.join('');
	}
}
</script>
<script type="text/javascript" src="http://api.awasete.com/showjson.phtml?u=<?php echo urlencode($u)?>"></script>
			<?php
		}
	}
	
	add_action('init', array('AwaseteYomitai_Widget','init'), 1);
}
